package com.eactive.eai.batch.job.jobItem.pension;

import com.eactive.eai.batch.flowController.DemandTargetVO;
import com.eactive.eai.batch.flowController.FlowControllerManager;
import com.eactive.eai.common.exception.ExceptionUtil;
import java.lang.String;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

/**
 * 퇴직연금용 0800 전문 수신용 텔레그램 클래스
 */
public class RECV_T0800_0001 extends DefaultTelegram implements TelegramService
{
    //>> 거래구분코드 정의
    // 업무개시
    private final String TrClass_start      = "0000100";
    private final String TrClass_end        = "0000200";
    private final String TrClass_linecheck  = "0000300";
    private final String TrClass_errnotify  = "0000400";
    private final String TrClass_oknotify   = "0000500";

    /**
     * 생성자
     */
    public RECV_T0800_0001() {
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        
        //거래구분코드 체크
        String bizCode = this.getTrClass();
        if (bizCode.equalsIgnoreCase(this.TrClass_start)) {
            logger.info("{} BATCH JOB : start request received", logHeader);
            
        } else if(bizCode.equalsIgnoreCase(this.TrClass_end)) {
            logger.info("{} BATCH JOB : end request received", logHeader);
            
        } else if(bizCode.equalsIgnoreCase(this.TrClass_linecheck)) {
            logger.info("{} BATCH JOB : 회선상태 확인 전문 수신 ", logHeader);
            
        } else if(bizCode.equalsIgnoreCase(this.TrClass_errnotify)) {
            logger.info("{} BATCH JOB : 대외기관시스템 장애 통보 수신", logHeader);
            
        } else if(bizCode.equalsIgnoreCase(this.TrClass_oknotify))  {
            logger.info("{} BATCH JOB : 대외기관시스템 장애회복 통보 수신", logHeader);
            
        } else {
            logger.info("{} 0800 telegram : unknown trasaction classification code received >> "+this.getTrClass(), logHeader);
        }

		//회선장애통보, 회선장애회복통보 처리
		if ("0000400,0000500".indexOf(this.getTrClass()) >= 0) {
			logger.info("{} >>>>> 퇴직연금 "+ (this.getTrClass().equals("0000400")? "회선장애통보" : "회선장애회복통보") +" 전문에 의한 회선 장애 상태 Updating...", logHeader);
			try {
				//시스템연결정보 테이블 (TSEAIBJ05) 회선 상태를 update 한다.
				FlowControllerManager.getInstance().updateSystemConnLineStatus(
									batchDoc.getBatchMsg().getHeader().getProcessCode(),
									batchDoc.getBatchMsg().getHeader().getInstitutionCode(),
									this.getTrClass().equals("0000400")? DemandTargetVO.ORGAN_SOCKET_STATUS_ERROR : DemandTargetVO.ORGAN_SOCKET_STATUS_NORNAL);  //0000400:장애, 0000500:회복

			} catch (Exception ex) {
                String errMsg = ExceptionUtil.getErrorCode(ex, "BECEAIFJI033", new String[] { batchDoc.getBatchMsg().getHeader().getProcessCode() });
                batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                super.setResolveResponseCode(TelegramKeys.RPS_HDB_RET_CODE_OTHER_ERROR);
                return false;
			}
		}

        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        
        //0800 전문에서 받은 파일명으로는 기수신여부를 체크하지 않는다.
        
        return true;
    }

    /**
     * doPostExecute
     */
    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
            /////////////////////////////////////////////////////////////
            /////////////////////////////////////////////////////////////
            logger.info("{}  doPostExecute called", logHeader);
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 비정형 필드에 대한 수신길이 계산
     */
    public int getCalculatedLength(int idx) {
        logger.info("{} getCalculatedLength unexpectedly called : idx = " + idx, logHeader);
        return 0;
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(8);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(9);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(12);
    }

}
